unless(defined(&_LINUX_CRYPTO_H)) {
    eval 'sub _LINUX_CRYPTO_H () {1;}' unless defined(&_LINUX_CRYPTO_H);
    eval 'sub CIPHER_NONE () {0;}' unless defined(&CIPHER_NONE);
    eval 'sub CIPHER_XOR () {1;}' unless defined(&CIPHER_XOR);
    eval 'sub CIPHER_DES () {2;}' unless defined(&CIPHER_DES);
    eval 'sub CIPHER_FISH2 () {3;}' unless defined(&CIPHER_FISH2);
    eval 'sub CIPHER_BLOWFISH () {4;}' unless defined(&CIPHER_BLOWFISH);
    eval 'sub CIPHER_CAST128 () {5;}' unless defined(&CIPHER_CAST128);
    eval 'sub CIPHER_IDEA () {6;}' unless defined(&CIPHER_IDEA);
    eval 'sub CIPHER_SERPENT () {7;}' unless defined(&CIPHER_SERPENT);
    eval 'sub CIPHER_MARS () {8;}' unless defined(&CIPHER_MARS);
    eval 'sub CIPHER_SKIPJACK () {10;}' unless defined(&CIPHER_SKIPJACK);
    eval 'sub CIPHER_RC6 () {11;}' unless defined(&CIPHER_RC6);
    eval 'sub CIPHER_3DES () {12;}' unless defined(&CIPHER_3DES);
    eval 'sub CIPHER_E2 () {13;}' unless defined(&CIPHER_E2);
    eval 'sub CIPHER_CAST256 () {14;}' unless defined(&CIPHER_CAST256);
    eval 'sub CIPHER_DFC () {15;}' unless defined(&CIPHER_DFC);
    eval 'sub CIPHER_RIJNDAEL () {16;}' unless defined(&CIPHER_RIJNDAEL);
    eval 'sub MAX_CIPHER () {20;}' unless defined(&MAX_CIPHER);
    eval 'sub CIPHER_CBC () {0x00010000;}' unless defined(&CIPHER_CBC);
    eval 'sub CIPHER_cbc_DES () {( &CIPHER_DES |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_DES);
    eval 'sub CIPHER_cbc_FISH2 () {( &CIPHER_FISH2 |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_FISH2);
    eval 'sub CIPHER_cbc_BLOWFISH () {( &CIPHER_BLOWFISH |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_BLOWFISH);
    eval 'sub CIPHER_cbc_CAST128 () {( &CIPHER_CAST128 |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_CAST128);
    eval 'sub CIPHER_cbc_IDEA () {( &CIPHER_IDEA |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_IDEA);
    eval 'sub CIPHER_cbc_SERPENT () {( &CIPHER_SERPENT |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_SERPENT);
    eval 'sub CIPHER_cbc_MARS () {( &CIPHER_MARS |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_MARS);
    eval 'sub CIPHER_cbc_SKIPJACK () {( &CIPHER_SKIPJACK |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_SKIPJACK);
    eval 'sub CIPHER_cbc_RC6 () {( &CIPHER_RC6 |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_RC6);
    eval 'sub CIPHER_cbc_3DES () {( &CIPHER_3DES |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_3DES);
    eval 'sub CIPHER_cbc_E2 () {( &CIPHER_E2 |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_E2);
    eval 'sub CIPHER_cbc_CAST256 () {( &CIPHER_CAST256 |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_CAST256);
    eval 'sub CIPHER_cbc_DFC () {( &CIPHER_DFC |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_DFC);
    eval 'sub CIPHER_cbc_RIJNDAEL () {( &CIPHER_RIJNDAEL |  &CIPHER_CBC);}' unless defined(&CIPHER_cbc_RIJNDAEL);
    if(defined(&__KERNEL__)) {
	require 'linux/lists.ph';
	require 'linux/kernel.ph';
	require 'asm/page.ph';
	require 'asm/semaphore.ph';
	require 'asm/spinlock.ph';
	eval 'sub MAX_KEY_SIZE () {8;}' unless defined(&MAX_KEY_SIZE);
	eval 'sub MAX_IV_SIZE () { &MAX_KEY_SIZE;}' unless defined(&MAX_IV_SIZE);
	eval 'sub CAST256_KEY_SCHEDULE_SIZE () {(96*$sizeof{ &u32});}' unless defined(&CAST256_KEY_SCHEDULE_SIZE);
	eval 'sub CRYPTON_KEY_SCHEDULE_SIZE () {(104*$sizeof{ &u32});}' unless defined(&CRYPTON_KEY_SCHEDULE_SIZE);
	eval 'sub SERPENT_KEY_SCHEDULE_SIZE () {(140*$sizeof{ &u32});}' unless defined(&SERPENT_KEY_SCHEDULE_SIZE);
	eval 'sub MARS_KEY_SCHEDULE_SIZE () {(40*$sizeof{ &u32});}' unless defined(&MARS_KEY_SCHEDULE_SIZE);
	eval 'sub RC6_KEY_SCHEDULE_SIZE () {(44*$sizeof{ &u32});}' unless defined(&RC6_KEY_SCHEDULE_SIZE);
	eval 'sub DFC_KEY_SCHEDULE_SIZE () {(32*$sizeof{ &u32});}' unless defined(&DFC_KEY_SCHEDULE_SIZE);
	eval 'sub RIJNDAEL_KEY_SCHEDULE_SIZE () {((60+60)*$sizeof{ &u32});}' unless defined(&RIJNDAEL_KEY_SCHEDULE_SIZE);
	eval 'sub BLOWFISH_KEY_SCHEDULE_SIZE () {((18+1024)*$sizeof{ &u32});}' unless defined(&BLOWFISH_KEY_SCHEDULE_SIZE);
	eval 'sub IDEA_KEY_SCHEDULE_SIZE () {(104*2);}' unless defined(&IDEA_KEY_SCHEDULE_SIZE);
	eval 'sub DES_KEY_SCHEDULE_SIZE () {(32*$sizeof{ &u32});}' unless defined(&DES_KEY_SCHEDULE_SIZE);
	eval 'sub DEFINE_GEN_CIPHER {
	    local($uppername, $name, $sname, $blocksize, $ivsize, $mode) = @_;
    	    eval q( &static \'struct cipher_implementation\' $mode$name = {  &DNODE_NULL,  &CIPHER_$mode$uppername, $sname, $blocksize, $ivsize, $uppername &_KEY_SCHEDULE_SIZE, $name &_$mode &encrypt, $name &_$mode &decrypt, $name &_set_key, $name &_lock, $name &_unlock });
	}' unless defined(&DEFINE_GEN_CIPHER);
	eval 'sub DEFINE_CIPHER {
	    local($uppername, $name, $sname, $blocksize, $ivsize) = @_;
    	    eval q( &DEFINE_GEN_CIPHER($uppername, $name, $sname, $blocksize, $ivsize, ));
	}' unless defined(&DEFINE_CIPHER);
	eval 'sub DEFINE_CBC_CIPHER {
	    local($uppername, $name, $sname, $ivsize) = @_;
    	    eval q( &DEFINE_GEN_CIPHER($uppername, $name, $sname, 0, $ivsize,  &cbc_));
	}' unless defined(&DEFINE_CBC_CIPHER);
	eval 'sub byte {
	    local($x, $nr) = @_;
    	    eval q((($x) >> ($nr*8)));
	}' unless defined(&byte);
    }
}
1;
